package net.sf.jasperreports.engine.xml;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.time.Day;
import org.jfree.data.time.Hour;
import org.jfree.data.time.Millisecond;
import org.jfree.data.time.Minute;
import org.jfree.data.time.Month;
import org.jfree.data.time.Quarter;
import org.jfree.data.time.Second;
import org.jfree.data.time.Week;
import org.jfree.data.time.Year;

public class JRXmlConstants {
  private static final String POSITION_TYPE_FLOAT = "Float";
  
  private static final String POSITION_TYPE_FIX_RELATIVE_TO_TOP = "FixRelativeToTop";
  
  private static final String POSITION_TYPE_FIX_RELATIVE_TO_BOTTOM = "FixRelativeToBottom";
  
  private static Map positionTypeMap = null;
  
  private static final String MODE_OPAQUE = "Opaque";
  
  private static final String MODE_TRANSPARENT = "Transparent";
  
  public static Map getPositionTypeMap() {
    if (positionTypeMap == null) {
      positionTypeMap = new HashMap(6);
      positionTypeMap.put("Float", new Byte((byte)1));
      positionTypeMap.put("FixRelativeToTop", new Byte((byte)2));
      positionTypeMap.put("FixRelativeToBottom", new Byte((byte)3));
      positionTypeMap.put(new Byte((byte)1), "Float");
      positionTypeMap.put(new Byte((byte)2), "FixRelativeToTop");
      positionTypeMap.put(new Byte((byte)3), "FixRelativeToBottom");
    } 
    return positionTypeMap;
  }
  
  private static Map modeMap = null;
  
  private static final String COLOR_BLACK = "black";
  
  private static final String COLOR_BLUE = "blue";
  
  private static final String COLOR_CYAN = "cyan";
  
  private static final String COLOR_DARK_GRAY = "darkGray";
  
  private static final String COLOR_GRAY = "gray";
  
  private static final String COLOR_GREEN = "green";
  
  private static final String COLOR_LIGHT_GRAY = "lightGray";
  
  private static final String COLOR_MAGENTA = "magenta";
  
  private static final String COLOR_ORANGE = "orange";
  
  private static final String COLOR_PINK = "pink";
  
  private static final String COLOR_RED = "red";
  
  private static final String COLOR_YELLOW = "yellow";
  
  private static final String COLOR_WHITE = "white";
  
  public static Map getModeMap() {
    if (modeMap == null) {
      modeMap = new HashMap(4);
      modeMap.put("Opaque", new Byte((byte)1));
      modeMap.put("Transparent", new Byte((byte)2));
      modeMap.put(new Byte((byte)1), "Opaque");
      modeMap.put(new Byte((byte)2), "Transparent");
    } 
    return modeMap;
  }
  
  private static Map colorMap = null;
  
  private static final String HORIZONTAL_ALIGN_LEFT = "Left";
  
  private static final String HORIZONTAL_ALIGN_CENTER = "Center";
  
  private static final String HORIZONTAL_ALIGN_RIGHT = "Right";
  
  private static final String HORIZONTAL_ALIGN_JUSTIFIED = "Justified";
  
  public static Map getColorMap() {
    if (colorMap == null) {
      colorMap = new HashMap(26);
      colorMap.put("black", Color.black);
      colorMap.put("blue", Color.blue);
      colorMap.put("cyan", Color.cyan);
      colorMap.put("darkGray", Color.darkGray);
      colorMap.put("gray", Color.gray);
      colorMap.put("green", Color.green);
      colorMap.put("lightGray", Color.lightGray);
      colorMap.put("magenta", Color.magenta);
      colorMap.put("orange", Color.orange);
      colorMap.put("pink", Color.pink);
      colorMap.put("red", Color.red);
      colorMap.put("yellow", Color.yellow);
      colorMap.put("white", Color.white);
      colorMap.put(Color.black, "black");
      colorMap.put(Color.blue, "blue");
      colorMap.put(Color.cyan, "cyan");
      colorMap.put(Color.darkGray, "darkGray");
      colorMap.put(Color.gray, "gray");
      colorMap.put(Color.green, "green");
      colorMap.put(Color.lightGray, "lightGray");
      colorMap.put(Color.magenta, "magenta");
      colorMap.put(Color.orange, "orange");
      colorMap.put(Color.pink, "pink");
      colorMap.put(Color.red, "red");
      colorMap.put(Color.yellow, "yellow");
      colorMap.put(Color.white, "white");
    } 
    return colorMap;
  }
  
  private static Map horizontalAlignMap = null;
  
  private static final String VERTICAL_ALIGN_TOP = "Top";
  
  private static final String VERTICAL_ALIGN_MIDDLE = "Middle";
  
  private static final String VERTICAL_ALIGN_BOTTOM = "Bottom";
  
  public static Map getHorizontalAlignMap() {
    if (horizontalAlignMap == null) {
      horizontalAlignMap = new HashMap(8);
      horizontalAlignMap.put("Left", new Byte((byte)1));
      horizontalAlignMap.put("Center", new Byte((byte)2));
      horizontalAlignMap.put("Right", new Byte((byte)3));
      horizontalAlignMap.put("Justified", new Byte((byte)4));
      horizontalAlignMap.put(new Byte((byte)1), "Left");
      horizontalAlignMap.put(new Byte((byte)2), "Center");
      horizontalAlignMap.put(new Byte((byte)3), "Right");
      horizontalAlignMap.put(new Byte((byte)4), "Justified");
    } 
    return horizontalAlignMap;
  }
  
  public static Map getTextAlignMap() {
    return getHorizontalAlignMap();
  }
  
  private static Map verticalAlignMap = null;
  
  private static final String ROTATION_NONE = "None";
  
  private static final String ROTATION_LEFT = "Left";
  
  private static final String ROTATION_RIGHT = "Right";
  
  private static final String ROTATION_UPSIDE_DOWN = "UpsideDown";
  
  public static Map getVerticalAlignMap() {
    if (verticalAlignMap == null) {
      verticalAlignMap = new HashMap(6);
      verticalAlignMap.put("Top", new Byte((byte)1));
      verticalAlignMap.put("Middle", new Byte((byte)2));
      verticalAlignMap.put("Bottom", new Byte((byte)3));
      verticalAlignMap.put(new Byte((byte)1), "Top");
      verticalAlignMap.put(new Byte((byte)2), "Middle");
      verticalAlignMap.put(new Byte((byte)3), "Bottom");
    } 
    return verticalAlignMap;
  }
  
  private static Map rotationMap = null;
  
  private static final String BREAK_TYPE_PAGE = "Page";
  
  private static final String BREAK_TYPE_COLUMN = "Column";
  
  public static Map getRotationMap() {
    if (rotationMap == null) {
      rotationMap = new HashMap(6);
      rotationMap.put("None", new Byte((byte)0));
      rotationMap.put("Left", new Byte((byte)1));
      rotationMap.put("Right", new Byte((byte)2));
      rotationMap.put("UpsideDown", new Byte((byte)3));
      rotationMap.put(new Byte((byte)0), "None");
      rotationMap.put(new Byte((byte)1), "Left");
      rotationMap.put(new Byte((byte)2), "Right");
      rotationMap.put(new Byte((byte)3), "UpsideDown");
    } 
    return rotationMap;
  }
  
  private static Map breakTypeMap = null;
  
  private static final String RUN_DIRECTION_LTR = "LTR";
  
  private static final String RUN_DIRECTION_RTL = "RTL";
  
  public static Map getBreakTypeMap() {
    if (breakTypeMap == null) {
      breakTypeMap = new HashMap(4);
      breakTypeMap.put("Page", new Byte((byte)1));
      breakTypeMap.put("Column", new Byte((byte)2));
      breakTypeMap.put(new Byte((byte)1), "Page");
      breakTypeMap.put(new Byte((byte)2), "Column");
    } 
    return breakTypeMap;
  }
  
  private static Map runDirectionMap = null;
  
  private static final String LINE_SPACING_SINGLE = "Single";
  
  private static final String LINE_SPACING_1_1_2 = "1_1_2";
  
  private static final String LINE_SPACING_DOUBLE = "Double";
  
  public static Map getRunDirectionMap() {
    if (runDirectionMap == null) {
      runDirectionMap = new HashMap(4);
      runDirectionMap.put("LTR", new Byte((byte)0));
      runDirectionMap.put("RTL", new Byte((byte)1));
      runDirectionMap.put(new Byte((byte)0), "LTR");
      runDirectionMap.put(new Byte((byte)1), "RTL");
    } 
    return runDirectionMap;
  }
  
  private static Map lineSpacingMap = null;
  
  private static final String DIRECTION_TOP_DOWN = "TopDown";
  
  private static final String DIRECTION_BOTTOM_UP = "BottomUp";
  
  public static Map getLineSpacingMap() {
    if (lineSpacingMap == null) {
      lineSpacingMap = new HashMap(6);
      lineSpacingMap.put("Single", new Byte((byte)0));
      lineSpacingMap.put("1_1_2", new Byte((byte)1));
      lineSpacingMap.put("Double", new Byte((byte)2));
      lineSpacingMap.put(new Byte((byte)0), "Single");
      lineSpacingMap.put(new Byte((byte)1), "1_1_2");
      lineSpacingMap.put(new Byte((byte)2), "Double");
    } 
    return lineSpacingMap;
  }
  
  private static Map directionMap = null;
  
  private static final String SCALE_IMAGE_CLIP = "Clip";
  
  private static final String SCALE_IMAGE_FILL_FRAME = "FillFrame";
  
  private static final String SCALE_IMAGE_RETAIN_SHAPE = "RetainShape";
  
  public static Map getDirectionMap() {
    if (directionMap == null) {
      directionMap = new HashMap(4);
      directionMap.put("TopDown", new Byte((byte)1));
      directionMap.put("BottomUp", new Byte((byte)2));
      directionMap.put(new Byte((byte)1), "TopDown");
      directionMap.put(new Byte((byte)2), "BottomUp");
    } 
    return directionMap;
  }
  
  private static Map scaleImageMap = null;
  
  private static final String ON_ERROR_TYPE_ERROR = "Error";
  
  private static final String ON_ERROR_TYPE_BLANK = "Blank";
  
  private static final String ON_ERROR_TYPE_ICON = "Icon";
  
  public static Map getScaleImageMap() {
    if (scaleImageMap == null) {
      scaleImageMap = new HashMap(6);
      scaleImageMap.put("Clip", new Byte((byte)1));
      scaleImageMap.put("FillFrame", new Byte((byte)2));
      scaleImageMap.put("RetainShape", new Byte((byte)3));
      scaleImageMap.put(new Byte((byte)1), "Clip");
      scaleImageMap.put(new Byte((byte)2), "FillFrame");
      scaleImageMap.put(new Byte((byte)3), "RetainShape");
    } 
    return scaleImageMap;
  }
  
  private static Map onErrorTypeMap = null;
  
  private static final String STRETCH_TYPE_NO_STRETCH = "NoStretch";
  
  private static final String STRETCH_TYPE_RELATIVE_TO_TALLEST_OBJECT = "RelativeToTallestObject";
  
  private static final String STRETCH_TYPE_RELATIVE_TO_BAND_HEIGHT = "RelativeToBandHeight";
  
  public static Map getOnErrorTypeMap() {
    if (onErrorTypeMap == null) {
      onErrorTypeMap = new HashMap(6);
      onErrorTypeMap.put("Error", new Byte((byte)1));
      onErrorTypeMap.put("Blank", new Byte((byte)2));
      onErrorTypeMap.put("Icon", new Byte((byte)3));
      onErrorTypeMap.put(new Byte((byte)1), "Error");
      onErrorTypeMap.put(new Byte((byte)2), "Blank");
      onErrorTypeMap.put(new Byte((byte)3), "Icon");
    } 
    return onErrorTypeMap;
  }
  
  private static Map stretchTypeMap = null;
  
  private static final String LINE_STYLE_SOLID = "Solid";
  
  private static final String LINE_STYLE_DASHED = "Dashed";
  
  private static final String LINE_STYLE_DOTTED = "Dotted";
  
  private static final String lINE_STYLE_DOUBLE = "Double";
  
  public static Map getStretchTypeMap() {
    if (stretchTypeMap == null) {
      stretchTypeMap = new HashMap(6);
      stretchTypeMap.put("NoStretch", new Byte((byte)0));
      stretchTypeMap.put("RelativeToTallestObject", new Byte((byte)1));
      stretchTypeMap.put("RelativeToBandHeight", new Byte((byte)2));
      stretchTypeMap.put(new Byte((byte)0), "NoStretch");
      stretchTypeMap.put(new Byte((byte)1), "RelativeToTallestObject");
      stretchTypeMap.put(new Byte((byte)2), "RelativeToBandHeight");
    } 
    return stretchTypeMap;
  }
  
  private static Map lineStyleMap = null;
  
  private static final String PEN_NONE = "None";
  
  private static final String PEN_THIN = "Thin";
  
  private static final String PEN_1_POINT = "1Point";
  
  private static final String PEN_2_POINT = "2Point";
  
  private static final String PEN_4_POINT = "4Point";
  
  private static final String PEN_DOTTED = "Dotted";
  
  public static Map getLineStyleMap() {
    if (lineStyleMap == null) {
      lineStyleMap = new HashMap(4);
      lineStyleMap.put("Solid", new Byte((byte)0));
      lineStyleMap.put("Dashed", new Byte((byte)1));
      lineStyleMap.put("Dotted", new Byte((byte)2));
      lineStyleMap.put("Double", new Byte((byte)3));
      lineStyleMap.put(new Byte((byte)0), "Solid");
      lineStyleMap.put(new Byte((byte)1), "Dashed");
      lineStyleMap.put(new Byte((byte)2), "Dotted");
      lineStyleMap.put(new Byte((byte)3), "Double");
    } 
    return lineStyleMap;
  }
  
  private static Map penMap = null;
  
  private static final String FILL_SOLID = "Solid";
  
  public static Map getPenMap() {
    if (penMap == null) {
      penMap = new HashMap(10);
      penMap.put("None", new Byte((byte)0));
      penMap.put("Thin", new Byte((byte)5));
      penMap.put("1Point", new Byte((byte)1));
      penMap.put("2Point", new Byte((byte)2));
      penMap.put("4Point", new Byte((byte)3));
      penMap.put("Dotted", new Byte((byte)4));
      penMap.put(new Byte((byte)0), "None");
      penMap.put(new Byte((byte)5), "Thin");
      penMap.put(new Byte((byte)1), "1Point");
      penMap.put(new Byte((byte)2), "2Point");
      penMap.put(new Byte((byte)3), "4Point");
      penMap.put(new Byte((byte)4), "Dotted");
    } 
    return penMap;
  }
  
  private static Map fillMap = null;
  
  private static final String RESET_TYPE_NONE = "None";
  
  private static final String RESET_TYPE_REPORT = "Report";
  
  private static final String RESET_TYPE_PAGE = "Page";
  
  private static final String RESET_TYPE_COLUMN = "Column";
  
  private static final String RESET_TYPE_GROUP = "Group";
  
  public static Map getFillMap() {
    if (fillMap == null) {
      fillMap = new HashMap(2);
      fillMap.put("Solid", new Byte((byte)1));
      fillMap.put(new Byte((byte)1), "Solid");
    } 
    return fillMap;
  }
  
  private static Map resetTypeMap = null;
  
  private static final String CALCULATION_NOTHING = "Nothing";
  
  private static final String CALCULATION_COUNT = "Count";
  
  private static final String CALCULATION_SUM = "Sum";
  
  private static final String CALCULATION_AVERAGE = "Average";
  
  private static final String CALCULATION_LOWEST = "Lowest";
  
  private static final String CALCULATION_HIGHEST = "Highest";
  
  private static final String CALCULATION_STANDARD_DEVIATION = "StandardDeviation";
  
  private static final String CALCULATION_VARIANCE = "Variance";
  
  private static final String CALCULATION_SYSTEM = "System";
  
  private static final String CALCULATION_FIRST = "First";
  
  private static final String CALCULATION_DISTINCT_COUNT = "DistinctCount";
  
  public static Map getResetTypeMap() {
    if (resetTypeMap == null) {
      resetTypeMap = new HashMap(10);
      resetTypeMap.put("None", new Byte((byte)5));
      resetTypeMap.put("Report", new Byte((byte)1));
      resetTypeMap.put("Page", new Byte((byte)2));
      resetTypeMap.put("Column", new Byte((byte)3));
      resetTypeMap.put("Group", new Byte((byte)4));
      resetTypeMap.put(new Byte((byte)5), "None");
      resetTypeMap.put(new Byte((byte)1), "Report");
      resetTypeMap.put(new Byte((byte)2), "Page");
      resetTypeMap.put(new Byte((byte)3), "Column");
      resetTypeMap.put(new Byte((byte)4), "Group");
    } 
    return resetTypeMap;
  }
  
  private static Map calculationMap = null;
  
  private static final String PRINT_ORDER_VERTICAL = "Vertical";
  
  private static final String PRINT_ORDER_HORIZONTAL = "Horizontal";
  
  public static Map getCalculationMap() {
    if (calculationMap == null) {
      calculationMap = new HashMap(18);
      calculationMap.put("Nothing", new Byte((byte)0));
      calculationMap.put("Count", new Byte((byte)1));
      calculationMap.put("Sum", new Byte((byte)2));
      calculationMap.put("Average", new Byte((byte)3));
      calculationMap.put("Lowest", new Byte((byte)4));
      calculationMap.put("Highest", new Byte((byte)5));
      calculationMap.put("StandardDeviation", new Byte((byte)6));
      calculationMap.put("Variance", new Byte((byte)7));
      calculationMap.put("System", new Byte((byte)8));
      calculationMap.put("First", new Byte((byte)9));
      calculationMap.put("DistinctCount", new Byte((byte)10));
      calculationMap.put(new Byte((byte)0), "Nothing");
      calculationMap.put(new Byte((byte)1), "Count");
      calculationMap.put(new Byte((byte)2), "Sum");
      calculationMap.put(new Byte((byte)3), "Average");
      calculationMap.put(new Byte((byte)4), "Lowest");
      calculationMap.put(new Byte((byte)5), "Highest");
      calculationMap.put(new Byte((byte)6), "StandardDeviation");
      calculationMap.put(new Byte((byte)7), "Variance");
      calculationMap.put(new Byte((byte)8), "System");
      calculationMap.put(new Byte((byte)9), "First");
      calculationMap.put(new Byte((byte)10), "DistinctCount");
    } 
    return calculationMap;
  }
  
  private static Map printOrderMap = null;
  
  private static final String ORIENTATION_PORTRAIT = "Portrait";
  
  private static final String ORIENTATION_LANDSCAPE = "Landscape";
  
  public static Map getPrintOrderMap() {
    if (printOrderMap == null) {
      printOrderMap = new HashMap(4);
      printOrderMap.put("Vertical", new Byte((byte)1));
      printOrderMap.put("Horizontal", new Byte((byte)2));
      printOrderMap.put(new Byte((byte)1), "Vertical");
      printOrderMap.put(new Byte((byte)2), "Horizontal");
    } 
    return printOrderMap;
  }
  
  private static Map orientationMap = null;
  
  private static final String WHEN_NO_DATA_TYPE_NO_PAGES = "NoPages";
  
  private static final String WHEN_NO_DATA_TYPE_BLANK_PAGE = "BlankPage";
  
  private static final String WHEN_NO_DATA_TYPE_ALL_SECTIONS_NO_DETAIL = "AllSectionsNoDetail";
  
  private static final String WHEN_NO_DATA_TYPE_NO_DATA_SECTION = "NoDataSection";
  
  public static Map getOrientationMap() {
    if (orientationMap == null) {
      orientationMap = new HashMap(4);
      orientationMap.put("Portrait", new Byte((byte)1));
      orientationMap.put("Landscape", new Byte((byte)2));
      orientationMap.put(new Byte((byte)1), "Portrait");
      orientationMap.put(new Byte((byte)2), "Landscape");
    } 
    return orientationMap;
  }
  
  private static Map whenNoDataTypeMap = null;
  
  private static final String EVALUATION_TIME_NOW = "Now";
  
  private static final String EVALUATION_TIME_REPORT = "Report";
  
  private static final String EVALUATION_TIME_PAGE = "Page";
  
  private static final String EVALUATION_TIME_COLUMN = "Column";
  
  private static final String EVALUATION_TIME_GROUP = "Group";
  
  private static final String EVALUATION_TIME_BAND = "Band";
  
  private static final String EVALUATION_TIME_AUTO = "Auto";
  
  public static Map getWhenNoDataTypeMap() {
    if (whenNoDataTypeMap == null) {
      whenNoDataTypeMap = new HashMap(6);
      whenNoDataTypeMap.put("NoPages", new Byte((byte)1));
      whenNoDataTypeMap.put("BlankPage", new Byte((byte)2));
      whenNoDataTypeMap.put("AllSectionsNoDetail", new Byte((byte)3));
      whenNoDataTypeMap.put("NoDataSection", new Byte((byte)4));
      whenNoDataTypeMap.put(new Byte((byte)1), "NoPages");
      whenNoDataTypeMap.put(new Byte((byte)2), "BlankPage");
      whenNoDataTypeMap.put(new Byte((byte)3), "AllSectionsNoDetail");
      whenNoDataTypeMap.put(new Byte((byte)4), "NoDataSection");
    } 
    return whenNoDataTypeMap;
  }
  
  private static Map evaluationTimeMap = null;
  
  private static final String HYPERLINK_TYPE_NONE = "None";
  
  private static final String HYPERLINK_TYPE_REFERENCE = "Reference";
  
  private static final String HYPERLINK_TYPE_LOCAL_ANCHOR = "LocalAnchor";
  
  private static final String HYPERLINK_TYPE_LOCAL_PAGE = "LocalPage";
  
  private static final String HYPERLINK_TYPE_REMOTE_ANCHOR = "RemoteAnchor";
  
  private static final String HYPERLINK_TYPE_REMOTE_PAGE = "RemotePage";
  
  public static Map getEvaluationTimeMap() {
    if (evaluationTimeMap == null) {
      evaluationTimeMap = new HashMap(10);
      evaluationTimeMap.put("Now", new Byte((byte)1));
      evaluationTimeMap.put("Report", new Byte((byte)2));
      evaluationTimeMap.put("Page", new Byte((byte)3));
      evaluationTimeMap.put("Column", new Byte((byte)4));
      evaluationTimeMap.put("Group", new Byte((byte)5));
      evaluationTimeMap.put("Band", new Byte((byte)6));
      evaluationTimeMap.put("Auto", new Byte((byte)7));
      evaluationTimeMap.put(new Byte((byte)1), "Now");
      evaluationTimeMap.put(new Byte((byte)2), "Report");
      evaluationTimeMap.put(new Byte((byte)3), "Page");
      evaluationTimeMap.put(new Byte((byte)4), "Column");
      evaluationTimeMap.put(new Byte((byte)5), "Group");
      evaluationTimeMap.put(new Byte((byte)6), "Band");
      evaluationTimeMap.put(new Byte((byte)7), "Auto");
    } 
    return evaluationTimeMap;
  }
  
  private static Map hyperlinkTypeMap = null;
  
  private static final String HYPERLINK_TARGET_SELF = "Self";
  
  private static final String HYPERLINK_TARGET_BLANK = "Blank";
  
  private static final String HYPERLINK_TARGET_PARENT = "Parent";
  
  private static final String HYPERLINK_TARGET_TOP = "Top";
  
  public static Map getHyperlinkTypeMap() {
    if (hyperlinkTypeMap == null) {
      hyperlinkTypeMap = new HashMap(12);
      hyperlinkTypeMap.put("None", new Byte((byte)1));
      hyperlinkTypeMap.put("Reference", new Byte((byte)2));
      hyperlinkTypeMap.put("LocalAnchor", new Byte((byte)3));
      hyperlinkTypeMap.put("LocalPage", new Byte((byte)4));
      hyperlinkTypeMap.put("RemoteAnchor", new Byte((byte)5));
      hyperlinkTypeMap.put("RemotePage", new Byte((byte)6));
      hyperlinkTypeMap.put(new Byte((byte)1), "None");
      hyperlinkTypeMap.put(new Byte((byte)2), "Reference");
      hyperlinkTypeMap.put(new Byte((byte)3), "LocalAnchor");
      hyperlinkTypeMap.put(new Byte((byte)4), "LocalPage");
      hyperlinkTypeMap.put(new Byte((byte)5), "RemoteAnchor");
      hyperlinkTypeMap.put(new Byte((byte)6), "RemotePage");
    } 
    return hyperlinkTypeMap;
  }
  
  private static Map hyperlinkTargetMap = null;
  
  private static final String EDGE_TOP = "Top";
  
  private static final String EDGE_BOTTOM = "Bottom";
  
  private static final String EDGE_LEFT = "Left";
  
  private static final String EDGE_RIGHT = "Right";
  
  public static Map getHyperlinkTargetMap() {
    if (hyperlinkTargetMap == null) {
      hyperlinkTargetMap = new HashMap(4);
      hyperlinkTargetMap.put("Self", new Byte((byte)1));
      hyperlinkTargetMap.put("Blank", new Byte((byte)2));
      hyperlinkTargetMap.put("Parent", new Byte((byte)3));
      hyperlinkTargetMap.put("Top", new Byte((byte)4));
      hyperlinkTargetMap.put(new Byte((byte)1), "Self");
      hyperlinkTargetMap.put(new Byte((byte)2), "Blank");
      hyperlinkTargetMap.put(new Byte((byte)3), "Parent");
      hyperlinkTargetMap.put(new Byte((byte)4), "Top");
    } 
    return hyperlinkTargetMap;
  }
  
  private static Map chartEdgeMap = null;
  
  private static final String ORIENTATION_HORIZONTAL = "Horizontal";
  
  private static final String ORIENTATION_VERTICAL = "Vertical";
  
  public static Map getChartEdgeMap() {
    if (chartEdgeMap == null) {
      chartEdgeMap = new HashMap(4);
      chartEdgeMap.put("Top", new Byte((byte)1));
      chartEdgeMap.put("Bottom", new Byte((byte)2));
      chartEdgeMap.put("Left", new Byte((byte)3));
      chartEdgeMap.put("Right", new Byte((byte)4));
      chartEdgeMap.put(new Byte((byte)1), "Top");
      chartEdgeMap.put(new Byte((byte)2), "Bottom");
      chartEdgeMap.put(new Byte((byte)3), "Left");
      chartEdgeMap.put(new Byte((byte)4), "Right");
    } 
    return chartEdgeMap;
  }
  
  public static Map getChartTitlePositionMap() {
    return getChartEdgeMap();
  }
  
  private static Map plotOrientationMap = null;
  
  private static final String SORT_ORDER_ASCENDING = "Ascending";
  
  private static final String SORT_ORDER_DESCENDING = "Descending";
  
  public static Map getPlotOrientationMap() {
    if (plotOrientationMap == null) {
      plotOrientationMap = new HashMap(4);
      plotOrientationMap.put("Horizontal", PlotOrientation.HORIZONTAL);
      plotOrientationMap.put("Vertical", PlotOrientation.VERTICAL);
      plotOrientationMap.put(PlotOrientation.HORIZONTAL, "Horizontal");
      plotOrientationMap.put(PlotOrientation.VERTICAL, "Vertical");
    } 
    return plotOrientationMap;
  }
  
  private static Map sortOrderMap = null;
  
  private static final String SCALE_ON_BOTH_AXES = "BothAxes";
  
  private static final String SCALE_ON_DOMAIN_AXIS = "DomainAxis";
  
  private static final String SCALE_ON_RANGE_AXIS = "RangeAxis";
  
  public static Map getSortOrderMap() {
    if (sortOrderMap == null) {
      sortOrderMap = new HashMap(4);
      sortOrderMap.put("Ascending", new Byte((byte)0));
      sortOrderMap.put("Descending", new Byte((byte)1));
      sortOrderMap.put(new Byte((byte)0), "Ascending");
      sortOrderMap.put(new Byte((byte)1), "Descending");
    } 
    return sortOrderMap;
  }
  
  private static Map scaleTypeMap = null;
  
  private static final String TIME_PERIOD_YEAR = "Year";
  
  private static final String TIME_PERIOD_QUARTER = "Quarter";
  
  private static final String TIME_PERIOD_MONTH = "Month";
  
  private static final String TIME_PERIOD_WEEK = "Week";
  
  private static final String TIME_PERIOD_DAY = "Day";
  
  private static final String TIME_PERIOD_HOUR = "Hour";
  
  private static final String TIME_PERIOD_MINUTE = "Minute";
  
  private static final String TIME_PERIOD_SECOND = "Second";
  
  private static final String TIME_PERIOD_MILISECOND = "Milisecond";
  
  private static final String WHEN_RESOURCE_MISSING_TYPE_NULL = "Null";
  
  private static final String WHEN_RESOURCE_MISSING_TYPE_EMPTY = "Empty";
  
  private static final String WHEN_RESOURCE_MISSING_TYPE_KEY = "Key";
  
  private static final String WHEN_RESOURCE_MISSING_TYPE_ERROR = "Error";
  
  public static Map getScaleTypeMap() {
    if (scaleTypeMap == null) {
      scaleTypeMap = new HashMap(6);
      scaleTypeMap.put("BothAxes", new Integer(0));
      scaleTypeMap.put("DomainAxis", new Integer(1));
      scaleTypeMap.put("RangeAxis", new Integer(2));
      scaleTypeMap.put(new Integer(0), "BothAxes");
      scaleTypeMap.put(new Integer(1), "DomainAxis");
      scaleTypeMap.put(new Integer(2), "RangeAxis");
    } 
    return scaleTypeMap;
  }
  
  public static Class getTimePeriod(String timePeriod) {
    if (timePeriod.equals("Year"))
      return Year.class; 
    if (timePeriod.equals("Quarter"))
      return Quarter.class; 
    if (timePeriod.equals("Month"))
      return Month.class; 
    if (timePeriod.equals("Week"))
      return Week.class; 
    if (timePeriod.equals("Day"))
      return Day.class; 
    if (timePeriod.equals("Hour"))
      return Hour.class; 
    if (timePeriod.equals("Minute"))
      return Minute.class; 
    if (timePeriod.equals("Second"))
      return Second.class; 
    return Millisecond.class;
  }
  
  public static String getTimePeriodName(Class clazz) {
    if (clazz.equals(Year.class))
      return "Year"; 
    if (clazz.equals(Quarter.class))
      return "Quarter"; 
    if (clazz.equals(Month.class))
      return "Month"; 
    if (clazz.equals(Week.class))
      return "Week"; 
    if (clazz.equals(Day.class))
      return "Day"; 
    if (clazz.equals(Hour.class))
      return "Hour"; 
    if (clazz.equals(Minute.class))
      return "Minute"; 
    if (clazz.equals(Second.class))
      return "Second"; 
    return "Milisecond";
  }
  
  private static Map whenResourceMissingTypeMap = null;
  
  private static final String METER_SHAPE_CHORD = "chord";
  
  private static final String METER_SHAPE_CIRCLE = "circle";
  
  private static final String METER_SHAPE_PIE = "pie";
  
  public static Map getWhenResourceMissingTypeMap() {
    if (whenResourceMissingTypeMap == null) {
      whenResourceMissingTypeMap = new HashMap();
      whenResourceMissingTypeMap.put("Null", new Byte((byte)1));
      whenResourceMissingTypeMap.put("Empty", new Byte((byte)2));
      whenResourceMissingTypeMap.put("Key", new Byte((byte)3));
      whenResourceMissingTypeMap.put("Error", new Byte((byte)4));
      whenResourceMissingTypeMap.put(new Byte((byte)1), "Null");
      whenResourceMissingTypeMap.put(new Byte((byte)2), "Empty");
      whenResourceMissingTypeMap.put(new Byte((byte)3), "Key");
      whenResourceMissingTypeMap.put(new Byte((byte)4), "Error");
    } 
    return whenResourceMissingTypeMap;
  }
  
  private static Map meterShapeMap = null;
  
  private static final String THERMOMETER_VALUE_LOCATION_NONE = "none";
  
  private static final String THERMOMETER_VALUE_LOCATION_LEFT = "left";
  
  private static final String THERMOMETER_VALUE_LOCATION_RIGHT = "right";
  
  private static final String THERMOMETER_VALUE_LOCATION_BULB = "bulb";
  
  public static Map getMeterShapeMap() {
    if (meterShapeMap == null) {
      meterShapeMap = new HashMap();
      meterShapeMap.put("chord", new Byte((byte)0));
      meterShapeMap.put("circle", new Byte((byte)1));
      meterShapeMap.put("pie", new Byte((byte)2));
      meterShapeMap.put(new Byte((byte)0), "chord");
      meterShapeMap.put(new Byte((byte)1), "circle");
      meterShapeMap.put(new Byte((byte)2), "pie");
    } 
    return meterShapeMap;
  }
  
  private static Map thermometerValueLocationMap = null;
  
  private static final String AXIS_POSITION_LEFT_OR_TOP = "leftOrTop";
  
  private static final String AXIS_POSITION_RIGHT_OR_BOTTOM = "rightOrBottom";
  
  public static Map getThermometerValueLocationMap() {
    if (thermometerValueLocationMap == null) {
      thermometerValueLocationMap = new HashMap();
      thermometerValueLocationMap.put("none", new Byte((byte)0));
      thermometerValueLocationMap.put("left", new Byte((byte)1));
      thermometerValueLocationMap.put("right", new Byte((byte)2));
      thermometerValueLocationMap.put("bulb", new Byte((byte)3));
      thermometerValueLocationMap.put(new Byte((byte)0), "none");
      thermometerValueLocationMap.put(new Byte((byte)1), "left");
      thermometerValueLocationMap.put(new Byte((byte)2), "right");
      thermometerValueLocationMap.put(new Byte((byte)3), "bulb");
    } 
    return thermometerValueLocationMap;
  }
  
  private static Map axisPositionMap = null;
  
  private static final String CROSSTAB_BUCKET_ORDER_ASCENDING = "Ascending";
  
  private static final String CROSSTAB_BUCKET_ORDER_DESCENDING = "Descending";
  
  public static Map getAxisPositionMap() {
    if (axisPositionMap == null) {
      axisPositionMap = new HashMap();
      axisPositionMap.put("leftOrTop", new Byte((byte)1));
      axisPositionMap.put("rightOrBottom", new Byte((byte)2));
      axisPositionMap.put(new Byte((byte)1), "leftOrTop");
      axisPositionMap.put(new Byte((byte)2), "rightOrBottom");
    } 
    return axisPositionMap;
  }
  
  private static Map crosstabBucketOrderMap = null;
  
  private static final String CROSSTAB_PERCENTAGE_NONE = "None";
  
  private static final String CROSSTAB_PERCENTAGE_GRAND_TOTAL = "GrandTotal";
  
  public static Map getCrosstabBucketOrderMap() {
    if (crosstabBucketOrderMap == null) {
      crosstabBucketOrderMap = new HashMap();
      crosstabBucketOrderMap.put("Ascending", new Byte((byte)1));
      crosstabBucketOrderMap.put("Descending", new Byte((byte)2));
      crosstabBucketOrderMap.put(new Byte((byte)1), "Ascending");
      crosstabBucketOrderMap.put(new Byte((byte)2), "Descending");
    } 
    return crosstabBucketOrderMap;
  }
  
  private static Map crosstabPercentageMap = null;
  
  private static final String CROSSTAB_TOTAL_POSITION_NONE = "None";
  
  private static final String CROSSTAB_TOTAL_POSITION_START = "Start";
  
  private static final String CROSSTAB_TOTAL_POSITION_END = "End";
  
  public static Map getCrosstabPercentageMap() {
    if (crosstabPercentageMap == null) {
      crosstabPercentageMap = new HashMap();
      crosstabPercentageMap.put("None", new Byte((byte)0));
      crosstabPercentageMap.put("GrandTotal", new Byte((byte)1));
      crosstabPercentageMap.put(new Byte((byte)0), "None");
      crosstabPercentageMap.put(new Byte((byte)1), "GrandTotal");
    } 
    return crosstabPercentageMap;
  }
  
  private static Map crosstabTotalPositionMap = null;
  
  private static final String CROSSTAB_ROW_POSITION_TOP = "Top";
  
  private static final String CROSSTAB_ROW_POSITION_MIDDLE = "Middle";
  
  private static final String CROSSTAB_ROW_POSITION_BOTTOM = "Bottom";
  
  private static final String CROSSTAB_ROW_POSITION_STRETCH = "Stretch";
  
  public static Map getCrosstabTotalPositionMap() {
    if (crosstabTotalPositionMap == null) {
      crosstabTotalPositionMap = new HashMap();
      crosstabTotalPositionMap.put("None", new Byte((byte)0));
      crosstabTotalPositionMap.put("Start", new Byte((byte)1));
      crosstabTotalPositionMap.put("End", new Byte((byte)2));
      crosstabTotalPositionMap.put(new Byte((byte)0), "None");
      crosstabTotalPositionMap.put(new Byte((byte)1), "Start");
      crosstabTotalPositionMap.put(new Byte((byte)2), "End");
    } 
    return crosstabTotalPositionMap;
  }
  
  private static Map crosstabRowPositionMap = null;
  
  private static final String CROSSTAB_COLUMN_POSITION_LEFT = "Left";
  
  private static final String CROSSTAB_COLUMN_POSITION_CENTER = "Center";
  
  private static final String CROSSTAB_COLUMN_POSITION_RIGHT = "Right";
  
  private static final String CROSSTAB_COLUMN_POSITION_STRETCH = "Stretch";
  
  public static Map getCrosstabRowPositionMap() {
    if (crosstabRowPositionMap == null) {
      crosstabRowPositionMap = new HashMap();
      crosstabRowPositionMap.put("Top", new Byte((byte)1));
      crosstabRowPositionMap.put("Middle", new Byte((byte)2));
      crosstabRowPositionMap.put("Bottom", new Byte((byte)3));
      crosstabRowPositionMap.put("Stretch", new Byte((byte)4));
      crosstabRowPositionMap.put(new Byte((byte)1), "Top");
      crosstabRowPositionMap.put(new Byte((byte)2), "Middle");
      crosstabRowPositionMap.put(new Byte((byte)3), "Bottom");
      crosstabRowPositionMap.put(new Byte((byte)4), "Stretch");
    } 
    return crosstabRowPositionMap;
  }
  
  private static Map crosstabColumnPositionMap = null;
  
  private static final String UNKNOWN = "unknown";
  
  private static final String BACKGROUND = "background";
  
  private static final String TITLE = "title";
  
  private static final String PAGE_HEADER = "pageHeader";
  
  private static final String COLUMN_HEADER = "columnHeader";
  
  private static final String GROUP_HEADER = "groupHeader";
  
  private static final String DETAIL = "detail";
  
  private static final String GROUP_FOOTER = "groupFooter";
  
  private static final String COLUMN_FOOTER = "columnFooter";
  
  private static final String PAGE_FOOTER = "pageFooter";
  
  private static final String LAST_PAGE_FOOTER = "lastPageFooter";
  
  private static final String SUMMARY = "summary";
  
  private static final String NO_DATA = "noData";
  
  public static Map getCrosstabColumnPositionMap() {
    if (crosstabColumnPositionMap == null) {
      crosstabColumnPositionMap = new HashMap();
      crosstabColumnPositionMap.put("Left", new Byte((byte)1));
      crosstabColumnPositionMap.put("Center", new Byte((byte)2));
      crosstabColumnPositionMap.put("Right", new Byte((byte)3));
      crosstabColumnPositionMap.put("Stretch", new Byte((byte)4));
      crosstabColumnPositionMap.put(new Byte((byte)1), "Left");
      crosstabColumnPositionMap.put(new Byte((byte)2), "Center");
      crosstabColumnPositionMap.put(new Byte((byte)3), "Right");
      crosstabColumnPositionMap.put(new Byte((byte)4), "Stretch");
    } 
    return crosstabColumnPositionMap;
  }
  
  private static Map bandTypeMap = null;
  
  public static final String JASPERREPORT_PUBLIC_ID = "-//JasperReports//DTD JasperReport//EN";
  
  public static final String JASPERREPORT_SYSTEM_ID = "http://jasperreports.sourceforge.net/dtds/jasperreport.dtd";
  
  public static final String JASPERREPORT_DTD = "net/sf/jasperreports/engine/dtds/jasperreport.dtd";
  
  public static final String JASPERPRINT_PUBLIC_ID = "-//JasperReports//DTD JasperPrint//EN";
  
  public static final String JASPERPRINT_SYSTEM_ID = "http://jasperreports.sourceforge.net/dtds/jasperprint.dtd";
  
  public static final String JASPERPRINT_DTD = "net/sf/jasperreports/engine/dtds/jasperprint.dtd";
  
  public static final String JASPERTEMPLATE_PUBLIC_ID = "-//JasperReports//DTD Template//EN";
  
  public static final String JASPERTEMPLATE_SYSTEM_ID = "http://jasperreports.sourceforge.net/dtds/jaspertemplate.dtd";
  
  public static final String JASPERTEMPLATE_DTD = "net/sf/jasperreports/engine/dtds/jaspertemplate.dtd";
  
  public static final String ELEMENT_jasperReport = "jasperReport";
  
  public static final String ATTRIBUTE_name = "name";
  
  public static final String ATTRIBUTE_language = "language";
  
  public static final String ATTRIBUTE_columnCount = "columnCount";
  
  public static final String ATTRIBUTE_printOrder = "printOrder";
  
  public static final String ATTRIBUTE_pageWidth = "pageWidth";
  
  public static final String ATTRIBUTE_pageHeight = "pageHeight";
  
  public static final String ATTRIBUTE_orientation = "orientation";
  
  public static final String ATTRIBUTE_whenNoDataType = "whenNoDataType";
  
  public static final String ATTRIBUTE_columnWidth = "columnWidth";
  
  public static final String ATTRIBUTE_columnSpacing = "columnSpacing";
  
  public static final String ATTRIBUTE_leftMargin = "leftMargin";
  
  public static final String ATTRIBUTE_rightMargin = "rightMargin";
  
  public static final String ATTRIBUTE_topMargin = "topMargin";
  
  public static final String ATTRIBUTE_bottomMargin = "bottomMargin";
  
  public static final String ATTRIBUTE_isTitleNewPage = "isTitleNewPage";
  
  public static final String ATTRIBUTE_isSummaryNewPage = "isSummaryNewPage";
  
  public static final String ATTRIBUTE_isFloatColumnFooter = "isFloatColumnFooter";
  
  public static final String ATTRIBUTE_scriptletClass = "scriptletClass";
  
  public static final String ATTRIBUTE_formatFactoryClass = "formatFactoryClass";
  
  public static final String ATTRIBUTE_resourceBundle = "resourceBundle";
  
  public static final String ATTRIBUTE_whenResourceMissingType = "whenResourceMissingType";
  
  public static final String ATTRIBUTE_isIgnorePagination = "isIgnorePagination";
  
  public static final String ATTRIBUTE_value = "value";
  
  public static final String ELEMENT_import = "import";
  
  public static final String ELEMENT_background = "background";
  
  public static final String ELEMENT_title = "title";
  
  public static final String ELEMENT_pageHeader = "pageHeader";
  
  public static final String ELEMENT_columnHeader = "columnHeader";
  
  public static final String ELEMENT_detail = "detail";
  
  public static final String ELEMENT_columnFooter = "columnFooter";
  
  public static final String ELEMENT_pageFooter = "pageFooter";
  
  public static final String ELEMENT_lastPageFooter = "lastPageFooter";
  
  public static final String ELEMENT_summary = "summary";
  
  public static final String ELEMENT_noData = "noData";
  
  public static final String ELEMENT_property = "property";
  
  public static final String ELEMENT_propertyExpression = "propertyExpression";
  
  public static final String ELEMENT_page = "page";
  
  public static final String ELEMENT_jasperPrint = "jasperPrint";
  
  public static final String ATTRIBUTE_locale = "locale";
  
  public static final String ATTRIBUTE_timezone = "timezone";
  
  public static final String ELEMENT_origin = "origin";
  
  public static final String ATTRIBUTE_report = "report";
  
  public static final String ATTRIBUTE_group = "group";
  
  public static final String ATTRIBUTE_band = "band";
  
  public static final String ELEMENT_band = "band";
  
  public static final String ELEMENT_printWhenExpression = "printWhenExpression";
  
  public static final String ATTRIBUTE_height = "height";
  
  public static final String ATTRIBUTE_isSplitAllowed = "isSplitAllowed";
  
  public static final String ELEMENT_pen = "pen";
  
  public static final String ATTRIBUTE_lineWidth = "lineWidth";
  
  public static final String ATTRIBUTE_lineStyle = "lineStyle";
  
  public static final String ATTRIBUTE_lineColor = "lineColor";
  
  public static final String ELEMENT_box = "box";
  
  public static final String ELEMENT_topPen = "topPen";
  
  public static final String ELEMENT_leftPen = "leftPen";
  
  public static final String ELEMENT_bottomPen = "bottomPen";
  
  public static final String ELEMENT_rightPen = "rightPen";
  
  public static final String ATTRIBUTE_border = "border";
  
  public static final String ATTRIBUTE_borderColor = "borderColor";
  
  public static final String ATTRIBUTE_padding = "padding";
  
  public static final String ATTRIBUTE_topBorder = "topBorder";
  
  public static final String ATTRIBUTE_topBorderColor = "topBorderColor";
  
  public static final String ATTRIBUTE_topPadding = "topPadding";
  
  public static final String ATTRIBUTE_leftBorder = "leftBorder";
  
  public static final String ATTRIBUTE_leftBorderColor = "leftBorderColor";
  
  public static final String ATTRIBUTE_leftPadding = "leftPadding";
  
  public static final String ATTRIBUTE_bottomBorder = "bottomBorder";
  
  public static final String ATTRIBUTE_bottomBorderColor = "bottomBorderColor";
  
  public static final String ATTRIBUTE_bottomPadding = "bottomPadding";
  
  public static final String ATTRIBUTE_rightBorder = "rightBorder";
  
  public static final String ATTRIBUTE_rightBorderColor = "rightBorderColor";
  
  public static final String ATTRIBUTE_rightPadding = "rightPadding";
  
  public static final String ELEMENT_break = "break";
  
  public static final String ATTRIBUTE_type = "type";
  
  public static final String ELEMENT_chart = "chart";
  
  public static final String ELEMENT_chartTitle = "chartTitle";
  
  public static final String ELEMENT_titleExpression = "titleExpression";
  
  public static final String ELEMENT_chartSubtitle = "chartSubtitle";
  
  public static final String ELEMENT_subtitleExpression = "subtitleExpression";
  
  public static final String ELEMENT_chartLegend = "chartLegend";
  
  public static final String ELEMENT_pieChart = "pieChart";
  
  public static final String ELEMENT_pie3DChart = "pie3DChart";
  
  public static final String ELEMENT_barChart = "barChart";
  
  public static final String ELEMENT_bar3DChart = "bar3DChart";
  
  public static final String ELEMENT_bubbleChart = "bubbleChart";
  
  public static final String ELEMENT_stackedBarChart = "stackedBarChart";
  
  public static final String ELEMENT_stackedBar3DChart = "stackedBar3DChart";
  
  public static final String ELEMENT_lineChart = "lineChart";
  
  public static final String ELEMENT_highLowChart = "highLowChart";
  
  public static final String ELEMENT_candlestickChart = "candlestickChart";
  
  public static final String ELEMENT_areaChart = "areaChart";
  
  public static final String ELEMENT_scatterChart = "scatterChart";
  
  public static final String ELEMENT_timeSeriesChart = "timeSeriesChart";
  
  public static final String ELEMENT_xyAreaChart = "xyAreaChart";
  
  public static final String ELEMENT_xyBarChart = "xyBarChart";
  
  public static final String ELEMENT_xyLineChart = "xyLineChart";
  
  public static final String ELEMENT_meterChart = "meterChart";
  
  public static final String ELEMENT_thermometerChart = "thermometerChart";
  
  public static final String ELEMENT_multiAxisChart = "multiAxisChart";
  
  public static final String ELEMENT_stackedAreaChart = "stackedAreaChart";
  
  public static final String ATTRIBUTE_isShowLegend = "isShowLegend";
  
  public static final String ATTRIBUTE_evaluationTime = "evaluationTime";
  
  public static final String ATTRIBUTE_evaluationGroup = "evaluationGroup";
  
  public static final String ATTRIBUTE_bookmarkLevel = "bookmarkLevel";
  
  public static final String ATTRIBUTE_customizerClass = "customizerClass";
  
  public static final String ATTRIBUTE_renderType = "renderType";
  
  public static final String ELEMENT_axisFormat = "axisFormat";
  
  public static final String ELEMENT_labelFont = "labelFont";
  
  public static final String ELEMENT_tickLabelFont = "tickLabelFont";
  
  public static final String ATTRIBUTE_labelColor = "labelColor";
  
  public static final String ATTRIBUTE_tickLabelColor = "tickLabelColor";
  
  public static final String ATTRIBUTE_tickLabelMask = "tickLabelMask";
  
  public static final String ATTRIBUTE_axisLineColor = "axisLineColor";
  
  public static final String ATTRIBUTE_textColor = "textColor";
  
  public static final String ATTRIBUTE_backgroundColor = "backgroundColor";
  
  public static final String ATTRIBUTE_position = "position";
  
  public static final String ATTRIBUTE_color = "color";
  
  public static final String ELEMENT_plot = "plot";
  
  public static final String ELEMENT_piePlot = "piePlot";
  
  public static final String ELEMENT_pie3DPlot = "pie3DPlot";
  
  public static final String ELEMENT_barPlot = "barPlot";
  
  public static final String ELEMENT_bubblePlot = "bubblePlot";
  
  public static final String ELEMENT_linePlot = "linePlot";
  
  public static final String ELEMENT_timeSeriesPlot = "timeSeriesPlot";
  
  public static final String ELEMENT_bar3DPlot = "bar3DPlot";
  
  public static final String ELEMENT_highLowPlot = "highLowPlot";
  
  public static final String ELEMENT_candlestickPlot = "candlestickPlot";
  
  public static final String ELEMENT_areaPlot = "areaPlot";
  
  public static final String ELEMENT_scatterPlot = "scatterPlot";
  
  public static final String ELEMENT_multiAxisPlot = "multiAxisPlot";
  
  public static final String ELEMENT_valueDisplay = "valueDisplay";
  
  public static final String ELEMENT_dataRange = "dataRange";
  
  public static final String ELEMENT_meterInterval = "meterInterval";
  
  public static final String ELEMENT_categoryAxisFormat = "categoryAxisFormat";
  
  public static final String ELEMENT_valueAxisFormat = "valueAxisFormat";
  
  public static final String ELEMENT_xAxisFormat = "xAxisFormat";
  
  public static final String ELEMENT_yAxisFormat = "yAxisFormat";
  
  public static final String ELEMENT_timeAxisFormat = "timeAxisFormat";
  
  public static final String ELEMENT_lowExpression = "lowExpression";
  
  public static final String ELEMENT_highExpression = "highExpression";
  
  public static final String ELEMENT_categoryAxisLabelExpression = "categoryAxisLabelExpression";
  
  public static final String ELEMENT_valueAxisLabelExpression = "valueAxisLabelExpression";
  
  public static final String ELEMENT_xAxisLabelExpression = "xAxisLabelExpression";
  
  public static final String ELEMENT_yAxisLabelExpression = "yAxisLabelExpression";
  
  public static final String ELEMENT_timeAxisLabelExpression = "timeAxisLabelExpression";
  
  public static final String ATTRIBUTE_backgroundAlpha = "backgroundAlpha";
  
  public static final String ATTRIBUTE_foregroundAlpha = "foregroundAlpha";
  
  public static final String ATTRIBUTE_labelRotation = "labelRotation";
  
  public static final String ATTRIBUTE_mask = "mask";
  
  public static final String ATTRIBUTE_label = "label";
  
  public static final String ATTRIBUTE_alpha = "alpha";
  
  public static final String ATTRIBUTE_depthFactor = "depthFactor";
  
  public static final String ATTRIBUTE_isShowLabels = "isShowLabels";
  
  public static final String ATTRIBUTE_isShowTickLabels = "isShowTickLabels";
  
  public static final String ATTRIBUTE_scaleType = "scaleType";
  
  public static final String ATTRIBUTE_isShowTickMarks = "isShowTickMarks";
  
  public static final String ATTRIBUTE_isShowLines = "isShowLines";
  
  public static final String ATTRIBUTE_isShowShapes = "isShowShapes";
  
  public static final String ATTRIBUTE_xOffset = "xOffset";
  
  public static final String ATTRIBUTE_yOffset = "yOffset";
  
  public static final String ATTRIBUTE_isShowOpenTicks = "isShowOpenTicks";
  
  public static final String ATTRIBUTE_isShowCloseTicks = "isShowCloseTicks";
  
  public static final String ATTRIBUTE_isShowVolume = "isShowVolume";
  
  public static final String ATTRIBUTE_isCircular = "isCircular";
  
  public static final String ELEMENT_seriesColor = "seriesColor";
  
  public static final String ATTRIBUTE_seriesOrder = "seriesOrder";
  
  public static final String ELEMENT_conditionalStyle = "conditionalStyle";
  
  public static final String ELEMENT_conditionExpression = "conditionExpression";
  
  public static final String ELEMENT_style = "style";
  
  public static final String ATTRIBUTE_isDefault = "isDefault";
  
  public static final String ATTRIBUTE_mode = "mode";
  
  public static final String ATTRIBUTE_forecolor = "forecolor";
  
  public static final String ATTRIBUTE_backcolor = "backcolor";
  
  public static final String ATTRIBUTE_style = "style";
  
  public static final String ATTRIBUTE_origin = "origin";
  
  public static final String ATTRIBUTE_radius = "radius";
  
  public static final String ATTRIBUTE_rotation = "rotation";
  
  public static final String ATTRIBUTE_lineSpacing = "lineSpacing";
  
  public static final String ATTRIBUTE_isStyledText = "isStyledText";
  
  public static final String ATTRIBUTE_markup = "markup";
  
  public static final String ATTRIBUTE_pattern = "pattern";
  
  public static final String ATTRIBUTE_isBlankWhenNull = "isBlankWhenNull";
  
  public static final String ATTRIBUTE_fontSize = "fontSize";
  
  public static final String ELEMENT_subDataset = "subDataset";
  
  public static final String ELEMENT_filterExpression = "filterExpression";
  
  public static final String ELEMENT_datasetRun = "datasetRun";
  
  public static final String ELEMENT_parametersMapExpression = "parametersMapExpression";
  
  public static final String ELEMENT_connectionExpression = "connectionExpression";
  
  public static final String ELEMENT_dataSourceExpression = "dataSourceExpression";
  
  public static final String ATTRIBUTE_subDataset = "subDataset";
  
  public static final String ELEMENT_datasetParameterExpression = "datasetParameterExpression";
  
  public static final String ELEMENT_datasetParameter = "datasetParameter";
  
  public static final String ELEMENT_dataset = "dataset";
  
  public static final String ELEMENT_categoryDataset = "categoryDataset";
  
  public static final String ELEMENT_timeSeriesDataset = "timeSeriesDataset";
  
  public static final String ELEMENT_timePeriodDataset = "timePeriodDataset";
  
  public static final String ELEMENT_xyzDataset = "xyzDataset";
  
  public static final String ELEMENT_xyDataset = "xyDataset";
  
  public static final String ELEMENT_pieDataset = "pieDataset";
  
  public static final String ELEMENT_valueDataset = "valueDataset";
  
  public static final String ELEMENT_highLowDataset = "highLowDataset";
  
  public static final String ELEMENT_categorySeries = "categorySeries";
  
  public static final String ELEMENT_xyzSeries = "xyzSeries";
  
  public static final String ELEMENT_xySeries = "xySeries";
  
  public static final String ELEMENT_timeSeries = "timeSeries";
  
  public static final String ELEMENT_timePeriodSeries = "timePeriodSeries";
  
  public static final String ELEMENT_incrementWhenExpression = "incrementWhenExpression";
  
  public static final String ELEMENT_keyExpression = "keyExpression";
  
  public static final String ELEMENT_valueExpression = "valueExpression";
  
  public static final String ELEMENT_labelExpression = "labelExpression";
  
  public static final String ELEMENT_seriesExpression = "seriesExpression";
  
  public static final String ELEMENT_categoryExpression = "categoryExpression";
  
  public static final String ELEMENT_xValueExpression = "xValueExpression";
  
  public static final String ELEMENT_yValueExpression = "yValueExpression";
  
  public static final String ELEMENT_zValueExpression = "zValueExpression";
  
  public static final String ELEMENT_timePeriodExpression = "timePeriodExpression";
  
  public static final String ELEMENT_startDateExpression = "startDateExpression";
  
  public static final String ELEMENT_endDateExpression = "endDateExpression";
  
  public static final String ELEMENT_dateExpression = "dateExpression";
  
  public static final String ELEMENT_openExpression = "openExpression";
  
  public static final String ELEMENT_closeExpression = "closeExpression";
  
  public static final String ELEMENT_volumeExpression = "volumeExpression";
  
  public static final String ATTRIBUTE_timePeriod = "timePeriod";
  
  public static final String ELEMENT_reportElement = "reportElement";
  
  public static final String ATTRIBUTE_key = "key";
  
  public static final String ATTRIBUTE_positionType = "positionType";
  
  public static final String ATTRIBUTE_stretchType = "stretchType";
  
  public static final String ATTRIBUTE_isPrintRepeatedValues = "isPrintRepeatedValues";
  
  public static final String ATTRIBUTE_x = "x";
  
  public static final String ATTRIBUTE_y = "y";
  
  public static final String ATTRIBUTE_width = "width";
  
  public static final String ATTRIBUTE_isRemoveLineWhenBlank = "isRemoveLineWhenBlank";
  
  public static final String ATTRIBUTE_isPrintInFirstWholeBand = "isPrintInFirstWholeBand";
  
  public static final String ATTRIBUTE_isPrintWhenDetailOverflows = "isPrintWhenDetailOverflows";
  
  public static final String ATTRIBUTE_printWhenGroupChanges = "printWhenGroupChanges";
  
  public static final String ELEMENT_elementGroup = "elementGroup";
  
  public static final String ELEMENT_ellipse = "ellipse";
  
  public static final String ELEMENT_field = "field";
  
  public static final String ELEMENT_fieldDescription = "fieldDescription";
  
  public static final String ATTRIBUTE_class = "class";
  
  public static final String ELEMENT_font = "font";
  
  public static final String ATTRIBUTE_reportFont = "reportFont";
  
  public static final String ATTRIBUTE_fontName = "fontName";
  
  public static final String ATTRIBUTE_isBold = "isBold";
  
  public static final String ATTRIBUTE_isItalic = "isItalic";
  
  public static final String ATTRIBUTE_isUnderline = "isUnderline";
  
  public static final String ATTRIBUTE_isStrikeThrough = "isStrikeThrough";
  
  public static final String ATTRIBUTE_size = "size";
  
  public static final String ATTRIBUTE_pdfFontName = "pdfFontName";
  
  public static final String ATTRIBUTE_pdfEncoding = "pdfEncoding";
  
  public static final String ATTRIBUTE_isPdfEmbedded = "isPdfEmbedded";
  
  public static final String ELEMENT_frame = "frame";
  
  public static final String ELEMENT_graphicElement = "graphicElement";
  
  public static final String ATTRIBUTE_pen = "pen";
  
  public static final String ATTRIBUTE_fill = "fill";
  
  public static final String ELEMENT_group = "group";
  
  public static final String ELEMENT_groupExpression = "groupExpression";
  
  public static final String ELEMENT_groupHeader = "groupHeader";
  
  public static final String ELEMENT_groupFooter = "groupFooter";
  
  public static final String ATTRIBUTE_isStartNewColumn = "isStartNewColumn";
  
  public static final String ATTRIBUTE_isStartNewPage = "isStartNewPage";
  
  public static final String ATTRIBUTE_isResetPageNumber = "isResetPageNumber";
  
  public static final String ATTRIBUTE_isReprintHeaderOnEachPage = "isReprintHeaderOnEachPage";
  
  public static final String ATTRIBUTE_minHeightToStartNewPage = "minHeightToStartNewPage";
  
  public static final String ELEMENT_hyperlinkTooltipExpression = "hyperlinkTooltipExpression";
  
  public static final String ELEMENT_sectionHyperlink = "sectionHyperlink";
  
  public static final String ELEMENT_itemHyperlink = "itemHyperlink";
  
  public static final String ELEMENT_anchorNameExpression = "anchorNameExpression";
  
  public static final String ELEMENT_hyperlinkReferenceExpression = "hyperlinkReferenceExpression";
  
  public static final String ELEMENT_hyperlinkAnchorExpression = "hyperlinkAnchorExpression";
  
  public static final String ELEMENT_hyperlinkPageExpression = "hyperlinkPageExpression";
  
  public static final String ATTRIBUTE_hyperlinkType = "hyperlinkType";
  
  public static final String ATTRIBUTE_hyperlinkTarget = "hyperlinkTarget";
  
  public static final String ELEMENT_hyperlinkParameterExpression = "hyperlinkParameterExpression";
  
  public static final String ELEMENT_hyperlinkParameter = "hyperlinkParameter";
  
  public static final String ELEMENT_image = "image";
  
  public static final String ELEMENT_imageSource = "imageSource";
  
  public static final String ELEMENT_imageExpression = "imageExpression";
  
  public static final String ATTRIBUTE_scaleImage = "scaleImage";
  
  public static final String ATTRIBUTE_hAlign = "hAlign";
  
  public static final String ATTRIBUTE_vAlign = "vAlign";
  
  public static final String ATTRIBUTE_isUsingCache = "isUsingCache";
  
  public static final String ATTRIBUTE_isLazy = "isLazy";
  
  public static final String ATTRIBUTE_onErrorType = "onErrorType";
  
  public static final String ELEMENT_line = "line";
  
  public static final String ATTRIBUTE_direction = "direction";
  
  public static final String ELEMENT_parameter = "parameter";
  
  public static final String ELEMENT_parameterDescription = "parameterDescription";
  
  public static final String ELEMENT_defaultValueExpression = "defaultValueExpression";
  
  public static final String ATTRIBUTE_isForPrompting = "isForPrompting";
  
  public static final String ELEMENT_hyperlinkParameterValue = "hyperlinkParameterValue";
  
  public static final String ATTRIBUTE_anchorName = "anchorName";
  
  public static final String ATTRIBUTE_hyperlinkReference = "hyperlinkReference";
  
  public static final String ATTRIBUTE_hyperlinkAnchor = "hyperlinkAnchor";
  
  public static final String ATTRIBUTE_hyperlinkPage = "hyperlinkPage";
  
  public static final String ATTRIBUTE_hyperlinkTooltip = "hyperlinkTooltip";
  
  public static final String ATTRIBUTE_isEmbedded = "isEmbedded";
  
  public static final String ATTRIBUTE_textAlignment = "textAlignment";
  
  public static final String ATTRIBUTE_verticalAlignment = "verticalAlignment";
  
  public static final String ATTRIBUTE_runDirection = "runDirection";
  
  public static final String ATTRIBUTE_textHeight = "textHeight";
  
  public static final String ATTRIBUTE_lineSpacingFactor = "lineSpacingFactor";
  
  public static final String ATTRIBUTE_leadingOffset = "leadingOffset";
  
  public static final String ATTRIBUTE_valueClass = "valueClass";
  
  public static final String ELEMENT_queryString = "queryString";
  
  public static final String ELEMENT_rectangle = "rectangle";
  
  public static final String ELEMENT_sortField = "sortField";
  
  public static final String ATTRIBUTE_order = "order";
  
  public static final String ELEMENT_staticText = "staticText";
  
  public static final String ELEMENT_text = "text";
  
  public static final String ELEMENT_textContent = "textContent";
  
  public static final String ATTRIBUTE_truncateIndex = "truncateIndex";
  
  public static final String ELEMENT_textTruncateSuffix = "textTruncateSuffix";
  
  public static final String ELEMENT_subreportExpression = "subreportExpression";
  
  public static final String ELEMENT_subreport = "subreport";
  
  public static final String ELEMENT_subreportParameter = "subreportParameter";
  
  public static final String ELEMENT_subreportParameterExpression = "subreportParameterExpression";
  
  public static final String ELEMENT_returnValue = "returnValue";
  
  public static final String ATTRIBUTE_subreportVariable = "subreportVariable";
  
  public static final String ATTRIBUTE_toVariable = "toVariable";
  
  public static final String ELEMENT_textElement = "textElement";
  
  public static final String ELEMENT_textFieldExpression = "textFieldExpression";
  
  public static final String ELEMENT_textField = "textField";
  
  public static final String ATTRIBUTE_isStretchWithOverflow = "isStretchWithOverflow";
  
  public static final String ELEMENT_variable = "variable";
  
  public static final String ELEMENT_variableExpression = "variableExpression";
  
  public static final String ELEMENT_initialValueExpression = "initialValueExpression";
  
  public static final String ATTRIBUTE_resetType = "resetType";
  
  public static final String ATTRIBUTE_resetGroup = "resetGroup";
  
  public static final String ATTRIBUTE_incrementType = "incrementType";
  
  public static final String ATTRIBUTE_incrementGroup = "incrementGroup";
  
  public static final String ATTRIBUTE_calculation = "calculation";
  
  public static final String ATTRIBUTE_incrementerFactoryClass = "incrementerFactoryClass";
  
  public static final String ELEMENT_reportFont = "reportFont";
  
  public static final String ELEMENT_template = "template";
  
  public static final String TEMPLATE_ELEMENT_ROOT = "jasperTemplate";
  
  public static final String TEMPLATE_ELEMENT_INCLUDED_TEMPLATE = "template";
  
  public static Map getBandTypeMap() {
    if (bandTypeMap == null) {
      bandTypeMap = new HashMap(24);
      bandTypeMap.put("unknown", new Byte((byte)0));
      bandTypeMap.put("background", new Byte((byte)1));
      bandTypeMap.put("title", new Byte((byte)2));
      bandTypeMap.put("pageHeader", new Byte((byte)3));
      bandTypeMap.put("columnHeader", new Byte((byte)4));
      bandTypeMap.put("groupHeader", new Byte((byte)5));
      bandTypeMap.put("detail", new Byte((byte)6));
      bandTypeMap.put("groupFooter", new Byte((byte)7));
      bandTypeMap.put("columnFooter", new Byte((byte)8));
      bandTypeMap.put("pageFooter", new Byte((byte)9));
      bandTypeMap.put("lastPageFooter", new Byte((byte)10));
      bandTypeMap.put("summary", new Byte((byte)11));
      bandTypeMap.put("noData", new Byte((byte)12));
      bandTypeMap.put(new Byte((byte)0), "unknown");
      bandTypeMap.put(new Byte((byte)1), "background");
      bandTypeMap.put(new Byte((byte)2), "title");
      bandTypeMap.put(new Byte((byte)3), "pageHeader");
      bandTypeMap.put(new Byte((byte)4), "columnHeader");
      bandTypeMap.put(new Byte((byte)5), "groupHeader");
      bandTypeMap.put(new Byte((byte)6), "detail");
      bandTypeMap.put(new Byte((byte)7), "groupFooter");
      bandTypeMap.put(new Byte((byte)8), "columnFooter");
      bandTypeMap.put(new Byte((byte)9), "pageFooter");
      bandTypeMap.put(new Byte((byte)10), "lastPageFooter");
      bandTypeMap.put(new Byte((byte)11), "summary");
      bandTypeMap.put(new Byte((byte)12), "noData");
    } 
    return bandTypeMap;
  }
  
  public static Color getColor(String strColor, Color defaultColor) {
    Color color = null;
    if (strColor != null && strColor.length() > 0) {
      char firstChar = strColor.charAt(0);
      if (firstChar == '#') {
        color = new Color(Integer.parseInt(strColor.substring(1), 16));
      } else if ('0' <= firstChar && firstChar <= '9') {
        color = new Color(Integer.parseInt(strColor));
      } else if (getColorMap().containsKey(strColor)) {
        color = (Color)getColorMap().get(strColor);
      } else {
        color = defaultColor;
      } 
    } 
    return color;
  }
}
